package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Helper methods
 */
public class Helper {

  /**
   * Avoiding Javadoc appearance (only static methods provided)
   */
  private Helper(){}

  /**
   * <p>Compute the maximum of three values.</p>
   *
   * @param a The first value.
   * @param b The second value.
   * @param c The third value
   * @return The largest of all three values.
   */
  static public int getMaximum(int a, int b, int c) {
    return Math.max(a, Math.max(b, c));
  }

  /**
   * <p>Compute the absolute value of the biggest difference between
   * two of three given numbers a, b, and c:</p>
   *
   * <table class="goikTableDefaults">
   *  <caption>Examples</caption>
   *   <tr>
   *     <th>Values</th>
   *     <th>Biggest absolute difference</th>
   *   </tr>
   *   <tr>
   *     <td><code>a = 1</code>, <code>b = 2</code>, <code>c = 10</code></td>
   *     <td>10 - 1 = 9</td>
   *   </tr>
   *
   *   <tr>
   *     <td><code>a = 4</code>, <code>b = 10</code>, <code>c = 6</code></td>
   *     <td>10 - 4 = 6</td>
   *   </tr>
   *
   *   <tr>
   *     <td><code>a = -3</code>, <code>b = 4</code>, <code>c = 3</code></td>
   *     <td>4 - (-3) = 7</td>
   *   </tr>
   *
   * </table>
   *
   * @param a The first of three parameters
   * @param b The second of three parameters
   * @param c The third of three parameters
   * @return The absolute value of the biggest difference between any possible pair
   * of all three parameters
   */
  static public int getMaxAbsoluteDiff(int a, int b, int c) {
    return getMaximum(Math.abs(a - b), Math.abs(a - c), Math.abs(b - c));
  }

  /**
   * <p>Copy a given string a number of times inserting a comma each time:</p>
   *
   * <table class="goikTableDefaults">
   *   <caption>Examples</caption>
   *   <tr>
   *     <th>Input string</th>
   *     <th>Count</th>
   *     <th>Result</th>
   *   </tr>
   *
   *   <tr>
   *       <td><code>But</code></td>
   *       <td><code>3</code></td>
   *       <td><code>But,But,But</code></td>
   *   </tr>
   *
   *   <tr>
   *       <td><code>yellow</code></td>
   *       <td><code>1</code></td>
   *       <td><code>yellow</code></td>
   *   </tr>
   *
   * </table>
   *
   * @param input An arbitrary not <code>null</code> string.
   * @param count A value greater than 0.
   * @return The value of count times the concatenation of the input string with itself each time adding a comma
   * in between.
   */
  static public String getMultipleCopy(final String input, final int count) {

    final StringBuffer buffer = new StringBuffer(input);
    for (int i = 1; i < count; i++) {
      buffer.append(',').append(input);
    }
    return buffer.toString();
  }

}
